{
    This file is part of the Free Pascal run time library.
    Copyright (c) 2006 Karoly Balogh

    exec functions (V40) for Amiga/PowerPC

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}

function Supervisor(userFunction: Pointer): Cardinal;
SysCall;

procedure InitCode(startClass: Cardinal;
                   version   : Cardinal);
SysCall;

procedure InitStruct(initTable: Pointer;
                     memory   : Pointer;
                     size     : Cardinal);
SysCall;

function MakeLibrary(funcInit  : Pointer;
                     structInit: Pointer;
                     libInit   : Pointer;
                     dataSize  : Cardinal;
                     segList   : Cardinal): PLibrary;
SysCall;

procedure MakeFunctions(target       : Pointer;
                        functionArray: Pointer;
                        funcDispBase : Pointer);
SysCall;

function FindResident(name: PChar): PResident;
SysCall;

function InitResident(resident: PResident;
                      segList : Cardinal): Pointer;
SysCall;

procedure Alert(alertNum: Cardinal);
SysCall;

procedure Debug(flags: Cardinal);
SysCall;

procedure Disable;
SysCall;

procedure Enable;
SysCall;

procedure Forbid;
SysCall;

procedure Permit;
SysCall;

function SetSR(newSR: Cardinal;
               mask : Cardinal): Cardinal;
SysCall;

function SuperState : Pointer;
SysCall;

procedure UserState(sysStack: Pointer);
SysCall;

function SetIntVector(intNumber: LongInt;
                      interrupt: PInterrupt): PInterrupt;
SysCall;

procedure AddIntServer(intNumber: LongInt;
                       interrupt: PInterrupt);
SysCall;

procedure RemIntServer(intNumber: LongInt;
                       interrupt: PInterrupt);
SysCall;

procedure Cause(interrupt: PInterrupt);
SysCall;

function Allocate(freeList: PMemHeader;
                  byteSize: Cardinal): Pointer;
SysCall;

procedure Deallocate(freeList   : PMemHeader;
                     memoryBlock: Pointer;
                     byteSize   : Cardinal);
SysCall;

{ * Name changed to avoid conflict with heap manager... * }
function execAllocMem(byteSize    : Cardinal;
                      requirements: Cardinal): Pointer;
SysCall;

function AllocAbs(byteSize: Cardinal;
                  location: Pointer): Pointer;
SysCall;

{ * Name changed to avoid conflict with heap manager... * }
procedure execFreeMem(memoryBlock: Pointer;
                      byteSize   : Cardinal);
SysCall;

function AvailMem(requirements: Cardinal): Cardinal;
SysCall;

function AllocEntry(entry: PMemList): PMemList;
SysCall;

procedure FreeEntry(entry: PMemList);
SysCall;

{ * Name changed to avoid conflict with other System unit call... * }
procedure execInsert(list: PList;
                     node: PNode;
                     pred: PNode);
SysCall;

procedure AddHead(list: PList;
                  node: PNode);
SysCall;

procedure AddTail(list: PList;
                  node: PNode);
SysCall;

procedure Remove(node: PNode);
SysCall;

function RemHead(list: PList): PNode;
SysCall;

function RemTail(list: PList): PNode;
SysCall;

procedure Enqueue(list: PList;
                  node: PNode);
SysCall;

function FindName(list: PList;
                  name: PChar): PNode;
SysCall;

function AddTask(task   : PTask;
                 initPC : Pointer;
                 finalPC: Pointer): Pointer;
SysCall;

procedure RemTask(task: PTask);
SysCall;

function FindTask(name: PChar): PTask;
SysCall;

function SetTaskPri(task    : PTask;
                    priority: LongInt): ShortInt;
SysCall;

function SetSignal(newSignals: Cardinal;
                   signalSet : Cardinal): Cardinal;
SysCall;

function SetExcept(newSignals: Cardinal;
                   signalSet : Cardinal): Cardinal;
SysCall;

function Wait(signalSet: Cardinal): Cardinal;
SysCall;

procedure Signal(task     : PTask;
                 signalSet: Cardinal);
SysCall;

function AllocSignal(signalNum: LongInt): ShortInt;
SysCall;

procedure FreeSignal(signalNum: LongInt);
SysCall;

function AllocTrap(trapNum: LongInt): LongInt;
SysCall;

procedure FreeTrap(trapNum: LongInt);
SysCall;

procedure AddPort(port: PMsgPort);
SysCall;

procedure RemPort(port: PMsgPort);
SysCall;

procedure PutMsg(port   : PMsgPort;
                 message: PMessage);
SysCall;

function GetMsg(port: PMsgPort): PMessage;
SysCall;

procedure ReplyMsg(message : PMessage);
SysCall;

function WaitPort(port: PMsgPort): PMessage;
SysCall;

function FindPort(name: PChar): PMsgPort;
SysCall;

procedure AddLibrary(libHandle: PLibrary);
SysCall;

procedure RemLibrary(libHandle: PLibrary);
SysCall;

function OldOpenLibrary(libName: PChar): PLibrary;
SysCall;

procedure CloseLibrary(libHandle: PLibrary);
SysCall;

function SetFunction(libHandle  : PLibrary;
                     funcOffset : LongInt;
                     newFunction: Pointer): Pointer;
SysCall;

procedure SumLibrary(libHandle: PLibrary);
SysCall;

procedure AddDevice(device: PDevice);
SysCall;

procedure RemDevice(device: PDevice);
SysCall;

function OpenDevice(devName  : PChar;
                    numunit  : Cardinal;
                    ioRequest: pIORequest;
                    flags    : Cardinal): ShortInt;
SysCall;

procedure CloseDevice(ioRequest: PIORequest);
SysCall;

function DoIO(ioRequest: PIORequest): ShortInt;
SysCall;

procedure SendIO(ioRequest: PIORequest);
SysCall;

function CheckIO(ioRequest: PIORequest): PIORequest;
SysCall;

function WaitIO(ioRequest: PIORequest): ShortInt;
SysCall;

procedure AbortIO(ioRequest: PIORequest);
SysCall;

procedure AddResource(resource: Pointer);
SysCall;

procedure RemResource(resource: Pointer);
SysCall;

function OpenResource(resName: PChar): Pointer;
SysCall;

procedure RawIOInit;
SysCall;

function RawMayGetChar: Char;
SysCall;

procedure RawPutChar(d0arg: Char);
SysCall;

function RawDoFmt(formatString: PChar;
                  dataStream  : Pointer;
                  putChProc   : Pointer;
                  putChData   : Pointer): Pointer;
SysCall;

function GetCC: Cardinal;
SysCall;

function TypeOfMem(address: Pointer): Cardinal;
SysCall;

function Procure(sigSem: PSignalSemaphore;
                 bidMsg: PSemaphoreMessage): Cardinal;
SysCall;

procedure Vacate(sigSem: PSignalSemaphore;
                 bidMsg: PSemaphoreMessage);
SysCall;

function OpenLibrary(libname: PChar;
                     libver : Cardinal): Pointer;
SysCall;

procedure InitSemaphore(sigSem: PSignalSemaphore);
SysCall;

procedure ObtainSemaphore(sigSem: PSignalSemaphore);
SysCall;

procedure ReleaseSemaphore(sigSem: PSignalSemaphore);
SysCall;

function AttemptSemaphore(sigSem: PSignalSemaphore): Cardinal;
SysCall;

procedure ObtainSemaphoreList(sigSem: PList);
SysCall;

procedure ReleaseSemaphoreList(sigSem: PList);
SysCall;

function FindSemaphore(sigSem: PChar): PSignalSemaphore;
SysCall;

procedure AddSemaphore(sigSem: PSignalSemaphore);
SysCall;

procedure RemSemaphore(sigSem: PSignalSemaphore);
SysCall;

function SumKickData: Cardinal;
SysCall;

procedure AddMemList(size      : Cardinal;
                     attributes: Cardinal;
                     pri       : LongInt;
                     base      : Pointer;
                     name      : PChar);
SysCall;

procedure CopyMem(source: Pointer;
                  dest  : Pointer;
                  size  : Cardinal);
SysCall;

procedure CopyMemQuick(source: Pointer;
                       dest  : Pointer;
                       size  : Cardinal);
SysCall;

procedure CacheClearU;
SysCall;

procedure CacheClearE(address: Pointer;
                      length : Cardinal;
                      caches : Cardinal);
SysCall;

function CacheControl(cacheBits: Cardinal;
                      cacheMask: Cardinal): Cardinal;
SysCall;

function CreateIORequest(port: PMsgPort;
                         size: Cardinal): Pointer;
SysCall;

procedure DeleteIORequest(iorequest: Pointer);
SysCall;

function CreateMsgPort: PMsgPort;
SysCall;

procedure DeleteMsgPort(port: PMsgPort);
SysCall;

procedure ObtainSemaphoreShared(sigSem: PSignalSemaphore);
SysCall;

function AllocVec(byteSize    : Cardinal;
                  requirements: Cardinal): Pointer;
SysCall;

procedure FreeVec(memoryBlock: Pointer);
SysCall;

function CreatePool(requirements: Cardinal;
                    puddleSize  : Cardinal;
                    threshSize  : Cardinal): Pointer;
SysCall;

procedure DeletePool(poolHeader: Pointer);
SysCall;

function AllocPooled(poolHeader: Pointer;
                     memSize   : Cardinal): Pointer;
SysCall;

function FreePooled(poolHeader: Pointer;
                    memory    : Pointer;
                    memSize   : Cardinal): Pointer;
SysCall;

function AttemptSemaphoreShared(sigSem: pSignalSemaphore): Cardinal;
SysCall;

procedure ColdReboot;
SysCall;

procedure StackSwap(newStack: PStackSwapStruct);
SysCall;

function NewGetTaskAttrsA(Task    : PTask;
                          Data    : Pointer;
                          DataSize: Cardinal;
                          TType   : Cardinal;
                          Tags    : PTagItem): Cardinal;
SysCall;

function NewSetTaskAttrsA(Task    : PTask;
                          Data    : Pointer;
                          DataSize: Cardinal;
                          TType   : Cardinal;
                          Tags    : PTagItem): Cardinal;
SysCall;

function CachePreDMA(address   : Pointer;
                     var length: Cardinal;
                     flags     : Cardinal): Pointer;
SysCall;

procedure CachePostDMA(address   : Pointer;
                       var length: Cardinal;
                       flags     : Cardinal);
SysCall;

procedure AddMemHandler(memhand: PInterrupt);
SysCall;

procedure RemMemHandler(memhand: PInterrupt);
SysCall;

function ObtainQuickVector(interruptCode: Pointer): Cardinal;
SysCall;

function NewSetFunction(libHandle  : PLibrary;
                        newfunction: Pointer;
                        offset     : LongInt;
                        tags       : PTagItem): Pointer;
SysCall;

function NewCreateLibrary(tags: PTagItem): PLibrary;
SysCall;

function TaggedOpenLibrary(d0arg: LongInt): Pointer;
SysCall;

function ReadGayle: Cardinal;
SysCall;

procedure CacheFlushDataArea(Address: Pointer;
                             Size   : Cardinal);
SysCall;

procedure CacheInvalidInstArea(Address: Pointer;
                               Size   : Cardinal);
SysCall;

procedure CacheInvalidDataArea(Address: Pointer;
                               Size   : Cardinal);
SysCall;

procedure CacheFlushDataInstArea(Address: Pointer;
                                 Size   : Cardinal);
SysCall;

procedure CacheTrashCacheArea(Address: Pointer;
                              Size   : Cardinal);
SysCall;

function AllocTaskPooled(Size: Cardinal): Pointer;
SysCall;

procedure FreeTaskPooled(Address: Pointer;
                         Size   : Cardinal);
SysCall;

function AllocVecTaskPooled(Size: Cardinal): Pointer;
SysCall;

procedure FreeVecTaskPooled(Address: Pointer);
SysCall;

procedure FlushPool(poolHeader: Pointer);
SysCall;

procedure FlushTaskPool;
SysCall;

function AllocVecPooled(poolHeader: Pointer;
                        memSize   : Cardinal): Pointer;
SysCall;

function NewGetSystemAttrsA(Data    : Pointer;
                            DataSize: Cardinal;
                            TType   : Cardinal;
                            Tags    : PTagItem): Cardinal;
SysCall;

function NewSetSystemAttrsA(Data    : Pointer;
                            DataSize: Cardinal;
                            TType   : Cardinal;
                            Tags    : PTagItem): Cardinal;
SysCall;

function NewCreateTaskA(Tags: PTagItem): PTask;
SysCall;


function FindExecNode(ttype: Cardinal;
                      name : PChar): PNode;
SysCall;

function AddExecNodeA(innode  : Pointer;
                      TagItems: PTagItem): Pointer;
SysCall;

function AllocVecDMA(byteSize    : Cardinal;
                     requirements: Cardinal): Pointer;
SysCall;

procedure FreeVecDMA(memoryBlock: Pointer);
SysCall;
